'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _dataTree = require('./helpers/dataTree');

var _dataTree2 = _interopRequireDefault(_dataTree);

var _util = require('./helpers/util');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Select = function (_React$Component) {
  (0, _inherits3.default)(Select, _React$Component);

  function Select(props) {
    (0, _classCallCheck3.default)(this, Select);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Select).call(this, props));

    ['onExpand', 'onSelect', 'onCheck', 'onChange', 'toggleMenuVisible', 'handleSearchInputChange', 'handleDocumentClick'].forEach(function (m) {
      _this[m] = _this[m].bind(_this);
    });

    _this.state = {
      /**
       * 用于渲染下拉菜单的数据，取自于Tree.props.data或List.props.data
       * 因为有搜索功能，这个data在搜索时会发生变化，所以需要在这里维护
       * @type {[type]}
       */
      data: [],
      /**
       * 显示、隐藏下拉菜单的标识
       * @type {Boolean}
       */
      menuVisible: false,
      /**
       * 树节点展开列表（搜索时用到，这里需要接管Tree.props.expanded）
       * @type {Array}
       */
      expanded: [],
      /**
       * 下拉框在选择后，输入框显示的值
       * @type {String}
       */
      inputValue: props.inputValue,
      /**
       * 搜索框显示的值
       * @type {String}
       */
      searchInputValue: undefined
    };
    /**
     * 初始化状态标识
     * 数据一般都是异步加载，在生成Component时，由于props.data为空，导致props.defaultChecked等值无效
     * 这里折中处理下，加一个状态标识，以便在props.data第一次不为空的情况下，取值于defaultChecked，而不是取值于checked
     */
    _this.initial = true;
    /**
     * 存储Tree, List组件的原有数据和事件
     */
    _this.menuProps = {
      data: [],
      onExpand: _util.noop,
      onSelect: _util.noop,
      onCheck: _util.noop,
      onChange: _util.noop
    };
    /**
     * 当前下拉菜单中的有效组件类型，Tree, List
     */
    _this.menuType = null;
    _this.searchInputRef = 'search-input';
    _this.initializeMenuProps(props);

    /**
     * 存储tree数据的类对象，用于数据搜索
     */
    _this.dataTree; // = new DataTree().import()
    /**
     * 用于阻止事件冒泡，参考react-overlay的做法
     */
    // 用了symbol 命名后，导致栈溢出.. 原因未知
    _this._suppressRootId = '__click_rt_select_was_inside__';
    _this._suppressRootCloseHandler = function (event) {
      event.nativeEvent[_this._suppressRootId] = true;
      event.stopPropagation();
    };
    return _this;
  }

  (0, _createClass3.default)(Select, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.unbindRootCloseHandlers();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.initializeMenuProps(nextProps);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var className = _props.className;
      var prefixCls = _props.prefixCls;
      var children = _props.children;
      var onClear = _props.onClear;
      var otherProps = (0, _objectWithoutProperties3.default)(_props, ['className', 'prefixCls', 'children', 'onClear']);


      return _react2.default.createElement(
        'div',
        (0, _extends3.default)({}, otherProps, { className: (0, _classnames2.default)(className, prefixCls) }),
        _react2.default.createElement(
          'div',
          { className: prefixCls + '-head', onClick: this.toggleMenuVisible },
          _react2.default.createElement(
            'label',
            { title: this.state.inputValue || this.props.placeholder },
            this.state.inputValue || this.props.placeholder
          ),
          this.state.inputValue && onClear ? _react2.default.createElement(
            'span',
            { className: 'clear-value-icon', onClick: this.clearSelected.bind(this) },
            '×'
          ) : null,
          _react2.default.createElement(
            'div',
            { className: 'dropdown-toggle' },
            _react2.default.createElement('i', null)
          )
        ),
        this.renderMenu()
      );
    }
  }, {
    key: 'renderMenu',
    value: function renderMenu() {
      var _this2 = this;

      var _props2 = this.props;
      var prefixCls = _props2.prefixCls;
      var children = _props2.children;
      var menuStyle = _props2.menuStyle;
      var emptyDataText = _props2.emptyDataText;
      var search = _props2.search;
      var searchInputPlaceholder = _props2.searchInputPlaceholder;
      var _state = this.state;
      var menuVisible = _state.menuVisible;
      var searchInputValue = _state.searchInputValue;

      var style = (0, _extends3.default)({}, menuStyle || {}, { display: menuVisible ? 'block' : 'none' });
      var maxHeight = style.maxHeight;
      var otherstyle = (0, _objectWithoutProperties3.default)(style, ['maxHeight']);

      return _react2.default.createElement(
        'div',
        { style: otherstyle, className: prefixCls + '-menu', onClick: this._suppressRootCloseHandler },
        _react2.default.Children.map(children, function (child) {
          // 节点为Tree组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
          var elementType = _this2.isValidElement(child);
          if (elementType) {

            // 检查数据是否有更新
            if (child.props !== _this2.menuProps) {
              _this2.updateMenuProps(child, elementType);
            }

            // 这里获取最新数据
            var _state2 = _this2.state;
            var data = _state2.data;
            var expanded = _state2.expanded;

            var element = void 0;

            if (!data || data.length <= 0) {
              element = _react2.default.createElement(
                'p',
                { className: 'empty-data-text' },
                emptyDataText
              );
            } else {
              var props = {
                data: data,
                bordered: false,
                expanded: expanded,
                onExpand: _this2.onExpand,
                onSelect: _this2.onSelect,
                onCheck: _this2.onCheck,
                onChange: _this2.onChange
              };

              element = _react2.default.cloneElement(child, props);
            }

            // 添加搜索框
            if (search) {
              var _maxHeight = _maxHeight || 150;
              element = _react2.default.createElement(
                'div',
                null,
                _react2.default.createElement(
                  'div',
                  { className: 'search-input-wrapper' },
                  _react2.default.createElement('input', {
                    ref: _this2.searchInputRef,
                    type: 'text',
                    placeholder: searchInputPlaceholder,
                    value: searchInputValue,
                    onChange: _this2.handleSearchInputChange }),
                  _react2.default.createElement('i', { className: 'icon-search' })
                ),
                _react2.default.createElement(
                  'div',
                  { style: { maxHeight: _maxHeight, overflow: 'auto' } },
                  element
                )
              );
            }

            return element;
          }

          return child;
        })
      );
    }
  }, {
    key: 'initializeMenuProps',
    value: function initializeMenuProps(props) {
      var _this3 = this;

      // TODO: 是否有必要遍历其所有子节点，找到这里需要接管的组件（Tree, List）？
      _react2.default.Children.forEach(props.children, function (child) {
        // 节点为Tree, List组件时，给它添加相应的属性与事件，以便Tree和Select关联起来
        var elementType = _this3.isValidElement(child);
        if (elementType) {
          _this3.updateMenuProps(child, elementType);
          return;
        }
      });
    }
  }, {
    key: 'updateMenuProps',
    value: function updateMenuProps(node, elementType) {
      // 把要接管的组件props存储起来，方便后面使用
      var _node$props = node.props;
      var data = _node$props.data;
      var expanded = _node$props.expanded;
      var defaultExpanded = _node$props.defaultExpanded;


      if (data !== this.menuProps.data) {
        // 重置state
        this.state.data = data;
        this.state.expanded = (this.initial ? expanded || defaultExpanded : expanded) || [];
        // this.state.inputValue = null
        this.state.searchInputValue = null;

        if (this.isTreeElement(elementType)) {
          this.dataTree = new _dataTree2.default().import(data.slice());
          // this.state.data = this.dataTree.export()
        }
      }

      // 如果menuProps.data已有数据，把initial设为false
      this.initial = !(this.initial && this.menuProps.data && this.menuProps.data.length > 0);
      this.menuProps = node.props;
      this.menuType = elementType;
      this.updateInputValue();
    }
  }, {
    key: 'updateInputValue',
    value: function updateInputValue() {
      var _this4 = this;

      var _menuProps = this.menuProps;
      var data = _menuProps.data;
      var commbox = _menuProps.commbox;
      var selected = _menuProps.selected;
      var defaultSeleced = _menuProps.defaultSeleced;
      var checked = _menuProps.checked;
      var defaultChecked = _menuProps.defaultChecked;


      var selectedValues = void 0,
          selectedDatas = [];

      if (commbox) {
        selectedValues = (this.initial ? checked || defaultChecked : checked) || [];
      } else {
        selectedValues = (this.initial ? selected || defaultSeleced : selected) || [];
      }

      // 根据节点选中项设置inputValue
      selectedValues.forEach(function (value) {
        var node = _this4.dataTree.searchDFS(function (data) {
          return data.id === value;
        });
        node && selectedDatas.push(node.data());
      });

      var inputValue = selectedDatas.map(function (o) {
        return o.text;
      }).join(', ');
      this.initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
    }

    /**
     * 判断是否有效的Tree, List组件，如果是，返回组件的类型，否则还回false
     * 由于并不依懒于Tree, List组件，所以这里仅以它的displayName来判断
     */

  }, {
    key: 'isValidElement',
    value: function isValidElement(element) {
      var elementType = element.type ? element.type.elementType : undefined;
      return elementType && (this.isTreeElement(elementType) || this.isListElement(elementType)) ? elementType : false;
    }
  }, {
    key: 'isTreeElement',
    value: function isTreeElement(elementType) {
      return (elementType || this.menuType) === _util.TREE_ELEMENT;
    }
  }, {
    key: 'isListElement',
    value: function isListElement(elementType) {
      return (elementType || this.menuType) === _util.LIST_ELEMENT;
    }
  }, {
    key: 'bindRootCloseHandlers',
    value: function bindRootCloseHandlers() {
      var doc = (0, _util.ownerDocument)(this);
      this._onDocumentClickListener = (0, _util.addEventListener)(doc, 'click', this.handleDocumentClick);
    }
  }, {
    key: 'unbindRootCloseHandlers',
    value: function unbindRootCloseHandlers() {
      if (this._onDocumentClickListener) {
        this._onDocumentClickListener.remove();
      }
    }
  }, {
    key: 'handleDocumentClick',
    value: function handleDocumentClick(e) {
      // This is now the native event.
      if (e[this._suppressRootId]) {
        return;
      }
      this.toggleMenuVisible();
    }
  }, {
    key: 'toggleMenuVisible',
    value: function toggleMenuVisible() {
      var _this5 = this;

      this.setState({
        menuVisible: !this.state.menuVisible
      }, function () {
        if (_this5.state.menuVisible) {
          _this5.bindRootCloseHandlers();

          // 让搜索框获得焦点
          if (_this5.props.search) {
            var input = _this5.refs[_this5.searchInputRef];
            input && input.focus();
          }
        } else if (!_this5.state.menuVisible) {
          _this5.unbindRootCloseHandlers();
        }
      });
    }
  }, {
    key: 'onExpand',
    value: function onExpand(expanded, node) {
      var nodeValue = node.props.value;
      // 这里维护Tree.props.expanded的值，因为在搜索时，会用到
      this.setState({
        expanded: expanded ? [].concat((0, _toConsumableArray3.default)(this.state.expanded), [nodeValue]) : this.state.expanded.filter(function (item) {
          return item !== nodeValue;
        })
      });
      this.menuProps.onExpand(expanded, node);
    }
  }, {
    key: 'onSelect',
    value: function onSelect(selected, value, data, node) {
      return this.onEvent('select', selected, value, data, node);
    }
  }, {
    key: 'onCheck',
    value: function onCheck(checked, value, data, node) {
      return this.onEvent('check', checked, value, data, node);
    }
  }, {
    key: 'onEvent',
    value: function onEvent(eventType, selected, value, data, node) {
      var selectToClose = this.props.selectToClose;
      var _menuProps2 = this.menuProps;
      var multiple = _menuProps2.multiple;
      var onSelect = _menuProps2.onSelect;
      var onCheck = _menuProps2.onCheck;

      var result = void 0;

      switch (eventType) {
        case 'select':
          result = onSelect(selected, value, data, node);break;
        case 'check':
          result = onCheck(selected, value, data, node);break;
      }

      if (!multiple && selected && selectToClose && result !== false) {
        this.toggleMenuVisible();
      }

      return result;
    }
  }, {
    key: 'selectToClose',
    value: function selectToClose() {
      var selectToClose = this.props.selectToClose;
      var multiple = this.menuProps.multiple;
      // 单选时，如果选中了选项，关闭下拉菜单

      if (!multiple && selected && selectToClose) {
        this.toggleMenuVisible();
      }
    }
  }, {
    key: 'onChange',
    value: function onChange(value, data, node) {
      this.menuProps.onChange(value, data, node);
    }
  }, {
    key: 'setInputValue',
    value: function setInputValue(data, initial) {
      var inputValue = void 0;
      // 把数据更新到input
      if (data) {
        if (Array.isArray(data)) {
          data.length > 0 && (inputValue = data.map(function (o) {
            return o.text;
          }).join(', '));
        } else {
          inputValue = data.text;
        }
      }
      initial ? this.state.inputValue = inputValue : this.setState({ inputValue: inputValue });
    }
  }, {
    key: 'clearSelected',
    value: function clearSelected(e) {
      e.stopPropagation();
      this.props.onClear && this.props.onClear();
    }
  }, {
    key: 'handleSearchInputChange',
    value: function handleSearchInputChange() {
      var searchInputValue = this.refs[this.searchInputRef].value;
      var result = void 0;

      // 使用输入法时，每次keyDown都会触发该onChange事件，但input的值实际上还没变更，这里判断一下
      if (searchInputValue !== this.state.searchInputValue) {
        // 过滤节点数据
        if (this.isTreeElement()) {
          result = this.filterTreeDatas(searchInputValue);
        } else {
          result = this.filterListDatas(searchInputValue);
        }

        this.setState((0, _extends3.default)({}, result || {}, {
          searchInputValue: searchInputValue
        }));
      }
    }
  }, {
    key: 'filterTreeDatas',
    value: function filterTreeDatas(keyWord) {
      var _this6 = this;

      var data = this.menuProps.data;

      var expanded = [];
      if (!keyWord) {
        return { data: data };
      }
      // 重置树节点数据
      var tree = this.dataTree;
      tree.import(data.slice());
      // 使用深度优先搜索算法搜索树节点
      tree.traverseDFS(function (node) {
        // 如果存在多各根节点的情形
        if (node._depth == 1 && node._childNodes.length > 1) {
          node._childNodes.forEach(function (nodeItem) {
            _this6.loopDFS_keyWord(nodeItem, expanded, keyWord);
          });
        } else {
          _this6.loopDFS_keyWord(node, expanded, keyWord);
        }
      });

      var afterFilter = this.filterExpanedTree(tree.export());
      // 重置
      this.dataTree.import(data.slice());

      // 只搜索到一个节点时，不展开该节点
      if (expanded.length === 1) return { data: afterFilter, expanded: [] };else if (expanded.length > 1) return { data: afterFilter, expanded: expanded };else return { data: null };
    }
  }, {
    key: 'loopDFS_keyWord',
    value: function loopDFS_keyWord(node, expanded, keyWord) {
      var _this7 = this;

      var nodeData = node.data();
      if (nodeData.text.indexOf(keyWord) > -1) {
        expanded.push(nodeData.id);
        (0, _assign2.default)(nodeData, { expanded: true });
        //获取它所有的祖先节点，把它的ID放到map中
        node.getAncestry().forEach(function (item) {
          var id = item.data().id;
          item.data((0, _extends3.default)({}, item.data(), { expanded: true }));
          if (_this7.contains(id, expanded) === false) {
            expanded.push(id);
          }
        });
      } else {
        // 为避免上次记录被保存，没有展开的再次遍历，设置false
        (0, _assign2.default)(nodeData, { expanded: false });
      }
    }

    // 数组中是否包含  

  }, {
    key: 'contains',
    value: function contains(id, arr) {
      var bool = false;
      arr.map(function (item) {
        if (item == id) {
          return bool = true;
        }
      });
      return bool;
    }

    // 对过滤展开的树进行递归筛选

  }, {
    key: 'filterExpanedTree',
    value: function filterExpanedTree(treeDatas) {
      var _this8 = this;

      var tree = [];
      var loopTree = function loopTree(trees, store) {
        Array.isArray(trees) && trees.map(function (item) {
          if (item.expanded === true) {
            var children = item.children;
            var node = (0, _objectWithoutProperties3.default)(item, ['children']);

            var childrens = _this8.childNodeHasExpaned(item.children) ? [] : item.children;
            (0, _assign2.default)(node, { children: childrens });
            store.push(node);
            loopTree(item.children, node.children);
          }
        });
      };
      loopTree(treeDatas, tree);
      return tree;
    }
  }, {
    key: 'filterListDatas',
    value: function filterListDatas(keyWord) {}
    // TODO

    // 判断其孩子中是否包含需要展开的节点。

  }, {
    key: 'childNodeHasExpaned',
    value: function childNodeHasExpaned(children) {
      // 假设没有
      var bool = false;
      Array.isArray(children) && children.forEach(function (item) {
        if (item.expanded === true) {
          return bool = true;
        }
      });
      return bool;
    }
  }]);
  return Select;
}(_react2.default.Component);

Select.propTypes = {
  /**
   * 下拉菜单的style
   * @type {Object}
   */
  menuStyle: _react.PropTypes.object,
  /**
   * 数据为空时，显示的文本信息
   * @type {String}
   */
  emptyDataText: _react.PropTypes.string,
  /**
   * 是否启用节点过滤功能
   * @type {Boolean}
   */
  search: _react.PropTypes.bool,
  /**
   * 查询框的placeholder值
   */
  searchInputPlaceholder: _react.PropTypes.string,
  /**
   * 选中时，是否自动关闭下拉菜单（仅单选有效）
   */
  selectToClose: _react.PropTypes.bool,
  /**
   * onClear 
   */
  onClear: _react.PropTypes.func,
  /**
   * [placeholder description]
   * @type {[type]}
   */
  placeholder: _react.PropTypes.string
};

Select.defaultProps = {
  prefixCls: 'rt-select',
  emptyDataText: '没有可显示的数据',
  searchInputPlaceholder: '搜索',
  selectToClose: true
};

exports.default = Select;